'-----------------------------------------------------
'Ansteuereungsbeispiel ohne ASM fr SR-LCD-Interface-Platine
'zum Betrieb an C-Control I Station
'CCTools 2003 cctools.hs-control.de (25.02.2003)
'Hinweis:
'Zum Betrieb ist es erforderlich die evtl. bestckten
'100nF-Kondensatoren 'an den fr SR-LCD benutzten
'Ports zu entfernen
'-----------------------------------------------------
define ds port[2]
define shclk port[1]
define stclk port[3]

define cmd byte[1]
define i byte[2]
define zahl byte[3]

define SRPorts byte[24]
define RS Bit[185]
define LCDLight Bit[187]
define SRPort1 Bit[188]
define SRPort2 Bit[189]
define SRPort3 Bit[190]
define SRPort4 Bit[191]
define SRPort5 Bit[192]

define LCD_RS_0 &B10 : define LCD_RS_1 &B11 :define LCD_nowrite &B0
define prnLCD &h150

'ASCII
Define A_ &H41 : Define B_ &H42 : Define C_ &H43 : Define D_ &H44 : Define E_ &H45
Define F_ &H46 : Define G_ &H47 : Define H_ &H48 : Define I_ &H49 : Define J_ &H4A
Define K_ &H4B : Define L_ &H4C : Define M_ &H4D : Define N_ &H4E : Define O_ &H4F
Define P_ &H50 : Define Q_ &H51 : Define R_ &H52 : Define S_ &H53 : Define T_ &H54
Define U_ &H55 : Define V_ &H56 : Define W_ &H57 : Define X_ &H58 : Define Y_ &H59 : Define Z_ &H5A
Define ak &H61 : Define bk &H62 : Define ck &H63 : Define dk &H64 : Define ek &H65
Define fk &H66 : Define gk &H67 : Define hk &H68 : Define ik &H69 : Define jk &H6A
Define kk &H6B : Define lk &H6C : Define mk &H6D : Define nk &H6E : Define ok &H6F
Define pk &H70 : Define qk &H71 : Define rk &H72 : Define sk &H73 : Define tk &H74
Define uk &H75 : Define vk &H76 : Define wk &H77 : Define xk &H78 : Define yk &H79 : Define zk &H7A
Define SPACE &H20 : Define MINUS &H2D : Define PLUS &H2B  : Define GLEICH &H3D
Define DPP &H3A   : Define Dot &H2E   : Define KLAUF &H28 : Define KLZU &H29
Define Line1 &H80 : Define Line2 &HC0 : Define Line3 &H94 : Define Line4 &HD4 'Fr 4x20 LCD
'Define Line1 &H80 : Define Line2 &HC0 : Define Line3 &H90 : Define Line4 &HD0 'Fr 4x16 LCD

gosub LCD_Init
SRPorts=0
LCDLight=ON : gosub setSRPorts
#loop
gosub LCD_CLS

zahl=hour : gosub LCD_Zahl2
cmd=DPP : gosub LCD_Char
i=minute : gosub LCD_Zahl2
cmd=DPP : gosub LCD_Char
zahl=second : gosub LCD_Zahl2

'cmd=Line3 : gosub LCD_CMD
'zahl=day : gosub LCD_Zahl2
'cmd=Dot : gosub LCD_Char
'zahl=month : gosub LCD_Zahl2
'sys prnLCD,LCD_RS_1 or SRPorts : print ".20";
'cmd=Dot : gosub LCD_Char
'cmd=&h32 : gosub LCD_Char
'cmd=&h30 : gosub LCD_Char
'zahl=year : gosub LCD_Zahl2null

cmd=Line2 : gosub LCD_CMD
'sys prnLCD,LCD_RS_1 or SRPorts : print "CCTools (c)2002";
cmd= C_ : gosub LCD_Char
cmd= C_ : gosub LCD_Char
cmd= T_ : gosub LCD_Char
cmd= ok : gosub LCD_Char
cmd= ok : gosub LCD_Char
cmd= lk : gosub LCD_Char
cmd= sk : gosub LCD_Char
cmd= Space : gosub LCD_Char
cmd= KLAUF : gosub LCD_Char
cmd= ck : gosub LCD_Char
cmd= KLZU : gosub LCD_Char
cmd= &H32 : gosub LCD_Char
cmd= &H30 : gosub LCD_Char
cmd= &H30 : gosub LCD_Char
cmd= &H32 : gosub LCD_Char


pause 45
gosub LCD_CLS
zahl=day : gosub LCD_Zahl2
cmd=Dot : gosub LCD_Char
zahl=month : gosub LCD_Zahl2
'sys prnLCD,LCD_RS_1 or SRPorts : print ".20";
cmd=Dot : gosub LCD_Char
cmd=&h32 : gosub LCD_Char
cmd=&h30 : gosub LCD_Char
zahl=year : gosub LCD_Zahl2null
cmd=Line2 : gosub LCD_CMD

'cmd=Line3 : gosub LCD_CMD
'sys prnLCD,LCD_RS_1 or SRPorts : print "Hello World";

'cmd=Line4 : gosub LCD_CMD
'sys prnLCD,LCD_RS_1 or SRPorts : print "SR-LCD";
cmd= H_ : gosub LCD_Char
cmd= ek : gosub LCD_Char
cmd= lk : gosub LCD_Char
cmd= lk : gosub LCD_Char
cmd= ok : gosub LCD_Char
cmd= SPACE : gosub LCD_Char
cmd= W_ : gosub LCD_Char
cmd= ok : gosub LCD_Char
cmd= rk : gosub LCD_Char
cmd= lk : gosub LCD_Char
cmd= dk : gosub LCD_Char
cmd= Space : gosub LCD_Char
cmd= S_ : gosub LCD_Char
cmd= R_ : gosub LCD_Char
cmd= L_ : gosub LCD_Char
cmd= C_ : gosub LCD_Char
cmd= D_ : gosub LCD_Char

pause 45
goto loop


'----LCD-Funktionen--------------------------
'Zahlausgaben
#LCD_Zahl3 ' 3 stellige Zahl ausgeben
if zahl > 99 then cmd=(zahl/100)+&h30 else cmd=SPACE
gosub LCD_Char
#LCD_Zahl2 ' 2 stellige Zahl ausgeben
if zahl > 9 then cmd=((zahl/10) mod 10)+&h30 else cmd=SPACE
gosub LCD_Char
#LCD_Zahl1 ' 1 stellige Zahl ausgeben
cmd= (zahl mod 10)+&h30
gosub LCD_Char
return
#LCD_Zahl3null ' 3 stellige Zahl ausgeben mit fhrender Nullen z.B.: 025 od. 005
cmd=(zahl/100)+&h30
gosub LCD_Char
#LCD_Zahl2null ' 2 stellige Zahl ausgeben mit fhrender Null z.B.: 05
cmd=((zahl/10) mod 10)+&h30
gosub LCD_Char
goto LCD_Zahl1

#LCD_CMD
RS=0
gosub sendLCDframe'sys &h101,cmd,LCD_RS_0 or SRPorts
RS=1
return
#LCD_Char
gosub sendLCDframe'sys &h101,cmd,LCD_RS_1 or SRPorts
return
#LCD_CLS
RS=off
cmd=&b00000001:gosub sendLCDframe'sys &h101,&b00000001,LCD_RS_0 or SRPorts
RS=on
return
#LCD_Init
ds=off
shclk=off
stclk=off
gosub setSRports'sys &h12e
RS=off
cmd=&b00111000:gosub sendLCDframe'sys &h101,&b00111000,LCD_RS_0
cmd=&b00001111:gosub sendLCDframe'sys &h101,&b00001111,LCD_RS_0
cmd=&b00000001:gosub sendLCDframe'sys &h101,&b00000001,LCD_RS_0
cmd=&b00001110:gosub sendLCDframe'sys &h101,&b00001110,LCD_RS_0
RS=on
return
#sendLCDframe
' for i = 5 to 1 step -1 'Auskommentiert fr ein wenig mehr Geschwindigkeit(SR-LCD-Ports)
'  if ((SRPorts shr i) and 1) then ds=on else ds=off
'  shclk=on
'  shclk=off
' next
 ds=LCDLight
 shclk=on
 shclk=off
 ds= on
 shclk=on
 shclk=off
 ds=RS
 shclk=on
 shclk=off
 for i = 7 to 0 step -1
'  if ((cmd shr i) and 1) then ds=on else ds=off
  ds= ((cmd shr i) and 1)
  shclk=on
  shclk=off
 next
 stclk=on
 stclk=off
#setSRports 'Portzustnde an SR-LCD aktualisieren(Ports & LCD-Beleuchtung)
''sys &h12e,SRPorts

' for i = 5 to 1 step -1 'Auskommentiert fr ein wenig mehr Geschwindigkeit(SR-LCD-Ports)
'  ds= ((SRPorts shr i) and 1)<>0
'  shclk=on
'  shclk=off
' next
 ds=LCDLight
 shclk=on
 shclk=off
 ds=off
 for i = 0 to 9
  shclk=on
  shclk=off
 next
 stclk=on
 stclk=off
return




